{$G+}

{What's new?}
{Pribyla funkce na zcernobileni obrazku a uvolneni obrazku z pameti (uz to chtelo)}
{Pribyly funkce na pridavani a zeslabovani gamma zareni a barev}

Unit vga256;

INTERFACE

const bufsize=1024;

type radek  =array[0..64000] of byte;
     uradek =^radek;
     rady   =array[0..16300] of uradek;
     kon    =^rady;

     obr=record
      xsize,ysize:word;
      rad:kon;
     end;

     TPCXheader = record
       Manufacturer : byte;             {Constant Flag, 10 = ZSoft .pcx}
       Version : byte;                  {Version information}
                                        {0 = Version 2.5 of PC Paintbrush
                                         2 = Version 2.8 w/palette information
                                         3 = Version 2.8 w/o palette information
                                         4 = PC Paintbrush for Windows(Plus for
                                             Windows uses Ver 5)
                                         5 = Version 3.0 and > of PC Paintbrush
                                             and PC Paintbrush +, includes
                                             Publisher's Paintbrush . Includes
                                             24-bit .PCX files}
       Encoding : byte;                 {1 = .PCX run length encoding}
       BitsPerPixel : byte;             {Number of bits to represent a pixel
                                         (per Plane) - 1, 2, 4, or 8}
       Window : record                  {Image Dimensions: Xmin,Ymin,Xmax,Ymax}
                  Xmin, Ymin, Xmax, Ymax : integer;
                end;
       HDpi : integer;                  {Horizontal Resolution of image in DPI*}
       VDpi : integer;                  {Vertical Resolution of image in DPI*}
       Colormap : array[0..47] of byte; {Color palette setting, see text}
       Reserved : byte;                 {Should be set to 0.}
       NPlanes : byte;                  {Number of color planes}
       BytesPerLine : integer;          {Number of bytes to allocate for a scanline
                                         plane.  MUST be an EVEN number.  Do NOT
                                         calculate from Xmax-Xmin.}
       PaletteInfo : integer;           {How to interpret palette- 1 = Color/BW,
                                         2 = Grayscale (ignored in PB IV/ IV +)}
       HscreenSize : integer;           {Horizontal screen size in pixels. New field
                                         found only in PB IV/IV Plus}
       VscreenSize : integer;           {Vertical screen size in pixels. New field
                                         found only in PB IV/IV Plus}
       Filler : array[0..53] of byte;   {Blank to fill out 128 byte header.  Set all
                                         bytes to 0 }
     end;

     TArray = array[0..65000] of byte;
     palbuf=array[0..767] of byte;

{Pcx grafika}
procedure dopcx(var kam:obr; filename:string);
procedure initpal_black(var pal:palbuf);
procedure initpal_red(var pal:palbuf);
procedure initpal_blue(var pal:palbuf);
procedure initpal_green(var pal:palbuf);
procedure drawobr(jakej:obr;pal:palbuf;x,y,x1,y1,x2,y2:integer);
procedure drawSobr(jakej:obr;pal:palbuf;x,y,x1,y1,x2,y2,pruhled:integer);
procedure getpal(var pal:palbuf; fn:string);
procedure increaseRlight(var pal:palbuf;okolik:integer);
procedure increaseGlight(var pal:palbuf;okolik:integer);
procedure increaseBlight(var pal:palbuf;okolik:integer);
procedure increasegamma(var pal:palbuf;kolik:byte);
procedure decreasegamma(var pal:palbuf;kolik:byte);
procedure initgraph;
procedure closegraph;
procedure vsync;
procedure zcernej;
procedure zbelej; {proc to nefacha?}
function initobr(var jakej:obr; sirka, vyska: integer):integer;
procedure setvgapalette(var pal:palbuf);
procedure msetvgapalette(var pal:palbuf);
Procedure FastMover(var source;var dest;numToMove: Word);
procedure killobr(var jakej:obr);
procedure GetVGAPalette (var PalBuf);
procedure docbobr(var pal:palbuf;var jakej:obr);

{Normalni grafika}
procedure line(x1,y1,x2,y2:integer;col:byte);
procedure cleardevice(barva:byte);
procedure rectangle(x,y,x1,y1:integer;col:byte);
procedure elipsa(xx,yy,polosirka,polovyska:integer;col:byte);
procedure circle(x,y : integer;r : word;c : byte);

{Krysa}
function lar:boolean;
function leftbutton:boolean;
function rightbutton:boolean;
procedure setmsen(hor,vert:integer);
procedure showmouse;
procedure hidemouse;
function getmousex:integer;
function getmousey:integer;
procedure setmousewindow(x,y,x1,y1:integer);
function mouseexist:boolean;
procedure setmousexy(x,y:integer);

IMPLEMENTATION

uses crt;

var f : file;
    Buf : ^TArray;
    Pos, Filled : word;

procedure rectangle(x,y,x1,y1:integer;col:byte);

begin
 line(x,y,x1,y,col);
 line(x,y,x,y1,col);
 line(x1,y,x1,y1,col);
 line(x,y1,x1,y1,col);
end;

procedure line(x1,y1,x2,y2:integer;col:byte);

var dx,dy,krok,k:integer;
    xprir,yprir,x,y:real;

begin
 dx:=x2-x1; dy:=y2-y1;
      if abs(dx)>abs(dy) then krok:=abs(dx)
 else krok:=abs(dy);
 if krok=0 then krok:=1;
 xprir:=dx/krok;
 yprir:=dy/krok;
 x:=x1;
 y:=y1;
 fastmover(col, mem[SegA000:round(y*320)+round(x)],1);
 for k:=1 to krok do begin
   x:=x+xprir;
   y:=y+yprir;
   fastmover(col, mem[SegA000:round(y*320)+round(x)],1);
 end;
end;

procedure elipsa(xx,yy,polosirka,polovyska:integer;col:byte);

var i:integer;
  x,y,oldx,oldy:real;

begin

for i:=0 to 359 do begin

 x:=cos(i/360*2*pi)*polosirka;
 y:=sin(i/360*2*pi)*polovyska;

 if i>1 then line(round(oldx)+xx,round(oldy)+yy,round(x)+xx,round(y)+yy,col);

 oldx:=x;
 oldy:=y;

 end;
end;

procedure circle(x,y : integer;r : word;c : byte);

var d,cx,cy : integer;

begin
     d := 3-(r+r);
     cx := 0;
     cy := r;
     while cx <= cy do begin
           mem[SegA000:(y+cy)*320+x+cx]:=c;
           mem[SegA000:(y-cy)*320+x+cx]:=c;
           mem[SegA000:(y+cy)*320+x-cx]:=c;
           mem[SegA000:(y-cy)*320+x-cx]:=c;
           mem[SegA000:(y+cx)*320+x+cy]:=c;
           mem[SegA000:(y-cx)*320+x+cy]:=c;
           mem[SegA000:(y+cx)*320+x-cy]:=c;
           mem[SegA000:(y-cx)*320+x-cy]:=c;
           inc(cx);
           if d < 0 then begin
              d := d+cx shl 2+6;
           end
           else begin
              d := d+(cx-cy) shl 2+10;
              dec(cy);
           end;
     end;
end;

function initobr(var jakej:obr; sirka, vyska: integer):integer;

var i:integer;

begin
 if maxavail<vyska*4 then initobr:=-1;
 getmem(jakej.rad,vyska*4);
 if maxavail<sirka*vyska then initobr:=-1;
  for i:=0 to vyska-1 do getmem(jakej.rad^[i],sirka);
 jakej.xsize:=sirka;
 jakej.ysize:=vyska;
end;

{Prace se souborem }

procedure InitFile (FN : string);
begin
  assign (f, FN);
  reset (f, 1);
  Pos:=0;
  GetMem (Buf, BufSize);
end;

procedure CloseFile;
begin
  FreeMem (Buf, BufSize);
  Close (f);
end;

function GetByte : byte;
begin
  if Pos=0 then BlockRead (f, Buf^, BufSize, Filled);
  GetByte:=Buf^[Pos];
  inc (Pos);
  if Pos=Filled then Pos:=0;
end;

procedure setcolor(var pal:palbuf;col,r,g,b:byte);

begin

 pal[col*3]:=r;
 pal[col*3+1]:=g;
 pal[col*3+2]:=b;

end;

Procedure initPal_blue(var pal:palbuf);

var t,i,j:byte;
    r,g,b:integer;

begin

 For t:=0 to 125 do   SetColor(pal,t,0,0,round(t*2));
 For t:=126 to 255  do SetColor(pal,t,round((t-126)*2),round((t-126)*2),255);
 SetColor(pal,0,0,0,0);

end;

Procedure initPal_green(var pal:palbuf);

var t,i,j:byte;
    r,g,b:integer;

begin

 For t:=0 to 125 do   SetColor(pal,t,0,round(t*2),0);
 For t:=126 to 255  do SetColor(pal,t,round((t-126)*2),255,round((t-126)*2));
 SetColor(pal,0,0,0,0);

end;

procedure initpal_red(var pal:palbuf);

var t,i,j:byte;
    r,g,b:integer;

begin

 For t:=0 to 125 do   SetColor(pal,t,round(t*2),0,0);
 For t:=126 to 255  do SetColor(pal,t,255,round((t-126)*2),round((t-126)*2));
 SetColor(pal,0,0,0,0);

end;

procedure getpal(var pal:palbuf;fn:string);

var f:file;

begin
 assign(f,fn);
 reset(f,1);
 seek(f,filesize(f)-768);
 blockread(f,pal,sizeof(pal));
 close(f);
end;

procedure dopcx(var kam:obr;FileName:String);
var h : TPCXHeader;
    Pal : array[0..767] of byte;
    Xsize, Ysize : integer;
    Line : ^TArray;
    x, y, i : integer;

    Pocet, Data : byte;

begin
  InitFile (FileName);
  BlockRead (f, h, SizeOf (f));
  if (h.Manufacturer<>10) or (h.Version<>5) or
     (h.Encoding<>1) or (h.BitsPerPixel<>8) then
  begin
    CloseFile;
    Exit;
  end;

  Seek (f, 128);
  with h.Window do
  begin
    Xsize:=Xmax-Xmin+1;
    Ysize:=Ymax-Ymin+1;
  end;

  GetMem (Line, h.BytesPerLine);
  initobr(kam,xsize,ysize);
  for y:=0 to Ysize-1 do
  begin
    x:=0;
    {Nacti ScanLine}
     while x<h.BytesPerLine do
    begin
      Data:=GetByte;
      if Data and $c0 = $c0 then
      begin
        Pocet:=Data and $3f;
        Data:=GetByte;
      end
      else Pocet:=1;

      for i:=1 to Pocet do
      begin
        Line^[x]:=Data;
        inc (x);
      end;

    end;

    {Dej ScanLine do pole v pameti}
    for x:=0 to Xsize-1 do kam.rad^[y]^[x]:=Line^[x];
  end;

  FreeMem (Line, h.BytesPerLine);

  CloseFile;
end;
{Rchly presunovani bloku pameti}

Procedure FastMover(var source;var dest;numToMove: Word);

 Begin
     InLine($8C / $DA / $C5 / $B6 / > SOURCE / $C4 / $BE / > DEST / $8B / $8E / > NUMTOMOVE);
     InLine($39 / $FE / $72 / $08 / $FC / $D1 / $E9 / $73 / $11 / $A4 / $EB / $0E / $FD / $01 / $CE);
     InLine($4E / $01 / $CF / $4F / $D1 / $E9 / $73 / $01 / $A4 / $4E / $4F / $F2 / $A5 / $8E / $DA);
     {:-))}
 End;

{Graficky veci}

procedure initgraph;assembler;
asm
 mov ax,13h
 int 10h
end;

procedure VSync; assembler;
asm
  mov  dx,3dah
@Wait:
  in   al,dx
  and  al,08h
  jz   @Wait
end;

procedure closegraph;assembler;
asm
 mov ax,3h
 int 10h
end;

procedure increasegamma(var pal:palbuf;kolik:byte);

var i:integer;

begin
 for i:=0 to 767 do if pal[i]<255 then inc(pal[i],kolik);
end;

procedure decreasegamma(var pal:palbuf;kolik:byte);

var i:integer;

begin
 for i:=0 to 767 do if pal[i]>0 then dec(pal[i],kolik);
end;

procedure initpal_black(var pal:palbuf);

var i:integer;

begin
 for i:=0 to 255 do begin
  pal[i*3]:=i;
  pal[i*3+1]:=i;
  pal[i*3+2]:=i;
 end;
end;

procedure docbobr(var pal:palbuf;var jakej:obr);

var i,j,r,g,b:integer;
    v:real;

begin
 for i:=0 to jakej.ysize-1 do
  for j:=0 to jakej.xsize-1 do begin
   r:=pal[jakej.rad^[i]^[j]*3];
   g:=pal[jakej.rad^[i]^[j]*3+1];
   b:=pal[jakej.rad^[i]^[j]*3+2];
   v:=0.2989*r+0.5866*g+0.1144*b;
   jakej.rad^[i]^[j]:=round(v);
  end;
  initpal_black(pal);
end;

procedure increaseRlight(var pal:palbuf;okolik:integer);

var i:integer;

begin
      for i:=0 to 255 do inc(pal[i*3],okolik);
end;

procedure increaseGlight(var pal:palbuf;okolik:integer);

var i:integer;

begin
      for i:=0 to 255 do inc(pal[i*3+1],okolik);
end;

procedure increaseBlight(var pal:palbuf;okolik:integer);

var i:integer;

begin
      for i:=0 to 255 do inc(pal[i*3+2],okolik);
end;
procedure SetVGAPalette (var pal:PalBuf);

var i:integer;

begin
for i:=0 to 767 do pal[i]:=pal[i] shr 2;
 asm
   push ds
   cld
   cli
   lds  si,Pal{Buf}
   mov  dx,$3C8
   xor  al,al
   out  dx,al
   inc  dx
   mov  cx,$300
   rep  outsb
   sti
   pop  ds
 end;
end;

procedure mSetVGAPalette (var pal:PalBuf);assembler;

 asm
   push ds
   cld
   cli
   lds  si,Pal{Buf}
   mov  dx,$3C8
   xor  al,al
   out  dx,al
   inc  dx
   mov  cx,$300
   rep  outsb
   sti
   pop  ds
 end;

procedure GetVGAPalette (var PalBuf); assembler;
asm
  les  di,[bp+6]
  cli
  cld
  mov  dx,$3C7
  xor  al,al
  out  dx,al
  inc  dx
  inc  dx
  mov  cx,$300
  rep  insb
  sti
end;
{}

procedure drawobr(jakej:obr;pal:palbuf;x,y,x1,y1,x2,y2:integer);

var i:integer;

begin
 setvgapalette(pal);
 for i:=y1 to y2 do fastmover(jakej.rad^[i]^[x1],mem[SegA000:(y+i-y1)*320+x],x2-x1);
end;

procedure drawSobr(jakej:obr;pal:palbuf;x,y,x1,y1,x2,y2,pruhled:integer);

var i,j:integer;

begin
 setvgapalette(pal);
 for i:=y1 to y2 do
  for j:=x1 to x2 do if jakej.rad^[i]^[j]<>pruhled then fastmover(jakej.rad^[i]^[j],mem[SegA000:(y+i-y1)*320+x+j-x1],1);
end;

procedure killobr(var jakej:obr);

var i:integer;

begin
 for i:=0 to jakej.ysize-1 do freemem(jakej.rad^[i],jakej.xsize);
 freemem(jakej.rad,jakej.ysize*4);
end;
{Krysa}
function lar:boolean;
var neco:integer;
begin
asm
 mov ax,3
 int $33
 mov [neco],bx
end;
     if neco=3 then lar:=true
else lar:=false;
end;

function rightbutton:boolean;
var neco:integer;
begin
asm
  mov ax,3
  int $33
  mov [neco],bx
end;
     if neco=2 then rightbutton:=true
else rightbutton:=false;
end;

function leftbutton:boolean;
var neco:integer;
begin
     asm
        mov ax,3
        int $33
        mov [neco],bx
     end;
     if neco=1 then leftbutton:=true
     else leftbutton:=false;
end;

procedure setmsen(hor,vert:integer);assembler;
asm
   mov ax,15
   mov cx,[vert]
   mov dx,[hor]
   int $33
end;

procedure showmouse;assembler;
asm
   mov ax,1
   int $33
end;

procedure hidemouse;assembler;
asm
   mov ax,2
   int $33
end;

function getmousex:integer;

var x:integer;

begin
asm
  mov ax,3
  int 33h
  mov [x],cx
end;
 getmousex:=round(x/2);
end;

procedure setmousexy(x,y:integer);
begin
 x:=round(x/2);
 asm
  mov ax,4
  mov cx,x
  mov dx,y
  int 33h
 end;
end;

function getmousey:integer;
var x:integer;
begin
asm
  mov ax,3
  int 33h
  mov [x],dx
end;
getmousey:=x;
end;

procedure setmousewindow(x,y,x1,y1:integer);
begin
x1:=x1+x1;
 asm
  mov ax,7
  mov cx,[x]
  mov dx,[x1]
  int 33h
  mov ax,8
  mov cx,[y]
  mov dx,[y1]
  int 33h
 end;
end;

function mouseexist:boolean;

var exist:integer;

begin
 asm
  mov ax,0
  int 33h
  mov [exist],ax
 end;
      if exist=0 then mouseexist:=true
 else mouseexist:=false;
end;

procedure zbelej;

var i:integer;
    pal:palbuf;

begin
 getvgapalette(pal);
 i:=0;
 repeat
  vsync;
  increasegamma(pal,1);
  msetvgapalette(pal);
{  vsync;}
  inc(i);
 until (i=63)or(keypressed);
end;

procedure zcernej;

var i:integer;
    pal:palbuf;

begin
 getvgapalette(pal);
 i:=0;
 repeat
  vsync;
  decreasegamma(pal,1);
  msetvgapalette(pal);
{  vsync;}
  inc(i);
 until (i=63)or(keypressed);
end;

procedure cleardevice(barva:byte);

begin
 fillchar(mem[SegA000:000],64000,barva);
end;

end.